/*
** CREATRIG.SQL
**
** This file creates triggers for the LIBRARY database.
**
** Don't forget to say 'USE library' first.
**
*/

PRINT 'Begin CREATRIG.SQL'
GO

USE Credit
SET NOCOUNT ON
GO
IF ( (SELECT db_name()) <> 'Credit')
BEGIN
   RAISERROR ('Database "Credit" not found.',22,127) WITH LOG
END
GO


/*    
** If the objects already exist (i.e., if this is a rebuild), drop them.
*/

IF EXISTS ( SELECT name FROM sysobjects
            WHERE type = 'TR' AND name = 'member_update' )
    DROP TRIGGER member_update
GO


/*
** Create triggers for the member table:
**     'Don't allow modification of primary keys'         update trigger.
*/



CREATE TRIGGER member_update
    ON member
    FOR update
AS
BEGIN
/*
** Don't allow modification of primary keys    
*/
    IF UPDATE (member_no)
    BEGIN
        PRINT 'This transaction will not be processed.'
        PRINT 'An existing member_no cannot be modified.'
        ROLLBACK TRANSACTION
    END
END
GO
